# Credits

I'm James. Building TinyBase was an interesting exercise in API design,
minification, and documentation. But now people seem to like using it!

I had the privilege of building this project just as I wanted, with as much time
as I needed, and for nothing other than my personal creativity. I wrote about
some of the interesting things I learned about having fewer constraints on a
software project,
[here](https://tripleodeon.com/2022/01/software-without-compromise/).

## Giants...

...upon whose shoulders TinyBase stands are numerous. There are no required
run-time dependencies, but at develop- and build- time, things are made a lot
easier by the following (non-exhaustive list) of awesome projects:

- [TypeScript](https://www.typescriptlang.org/) for typing
- [ESLint](https://eslint.org/) (and various plugins) for linting
- [Prettier](https://prettier.io/) for formatting
- [CSpell](https://github.com/streetsidesoftware/cspell) for spell-checking
- [ESBuild](https://esbuild.github.io/) for transpilation
- [React](https://reactjs.org/) for UI and documentation
- [LESS](https://lesscss.org/) for styling
- [Rollup](https://rollupjs.org/) for bundling
- [Gulp](https://gulpjs.com/) for build orchestration
- [Jest](https://jestjs.io/) for testing
- [TypeDoc](https://typedoc.org/) for documentation
- [asciichart](https://github.com/kroitor/asciichart) for performance charting
- [Puppeteer](https://pptr.dev/) for browser automation

## ...And Friends

Such as those of you who provided feedback on TinyBase before it launched. You
were very polite, even when it didn't make sense. And maybe it still doesn't,
but I tried!

- [Christopher Chedeau](https://twitter.com/Vjeux)
- [Dion Almaer](https://twitter.com/dalmaer)
- [Adam Wolff](https://twitter.com/dmwlff)
- [Michael Bolin](https://twitter.com/bolinfest)
- [Michael Mullaney](https://twitter.com/mmullany)
- [Adrien Friggeri](https://twitter.com/friggeri)
- Paul Yiu

Thank you all!
